//
// Created by Fear1ess on 2021/4/2.
//

#include "collect.h"
#include "jni_helper.h"
#include "utils.h"

extern jobject g_app_context;

cJSON *collect_init() {
    return cJSON_CreateObject();
}

void do_collect(JNIEnv* env) {
    cJSON* json =  collect_init();
    collect_app_info(env, json);
}

void collect_app_info(JNIEnv* env, cJSON *json) {
    //package_name
    jobject pkgName = wdCallObjectMethod(env, g_app_context, "getPackageName", "()Ljava/lang/String;");
    addJniStringToJson(env, json, "package_name", pkgName);

    //get packagemanager and pkginfo
    jobject pkgManager = wdCallObjectMethod(env, g_app_context, "getPackageManager", "()Landroid/content/pm/PackageManager;");
    jobject pkgInfo = wdCallObjectMethod(env, pkgManager, "getPackageInfo", "(Ljava/lang/String;I)Landroid/content/pm/PackageInfo;", pkgName, 0);

    //last update time
    jlong lastUpdateTime = wdGetLongField(env, pkgInfo, "lastUpdateTime", "J");
    cJSON_AddNumberToObject(json, "last_update_time", lastUpdateTime);

    const char* info = cJSON_Print(json);
    (*env)->DeleteLocalRef(env, pkgName);
    return;
}

